package com.example.vaadincustomlayout;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.Button;
import com.vaadin.ui.Component;
import com.vaadin.ui.CustomLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.UI;
import com.vaadin.ui.Button.ClickEvent;

@SuppressWarnings("serial")
@Theme("vaadincustomlayout")
public class VaadincustomlayoutUI extends UI {

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = VaadincustomlayoutUI.class, widgetset = "com.example.vaadincustomlayout.widgetset.VaadincustomlayoutWidgetset")
	public static class Servlet extends VaadinServlet {
	}

	@Override
	protected void init(VaadinRequest request) {
		CustomLayout layout = new CustomLayout("mainlayout");
		setContent(layout);
		
		Label centerLabel = new Label("Center");
		centerLabel.addStyleName("centerlabel");
		
		Button.ClickListener leftListener = new Button.ClickListener() {
			
			@Override
			public void buttonClick(ClickEvent event) {
				
				centerLabel.setValue(event.getButton().getCaption());
				
			}
		};
		
		Button.ClickListener rightListener = new Button.ClickListener() {
			
			@Override
			public void buttonClick(ClickEvent event) {
				
				String capt = event.getButton().getCaption();
				String val = "empty";
				
				if(capt.equals("B01")){
					val = "Right Button one";
				}
				
				if(capt.equals("B02")){
					val = "Right Button two";
				}

				if(capt.equals("B03")){
					val = "Right Button three";
				}

				if(capt.equals("B04")){
					val = "Right Button four";
				}

				centerLabel.setValue(val);
				
			}
		};

		CustomLayout leftmenu = new CustomLayout("leftmenu");
		Button firstButton = new Button("First Button");
		firstButton.setWidth("200px");
		firstButton.addStyleName("primary");
		firstButton.addClickListener(leftListener);
		leftmenu.addComponent((Component) firstButton, "first");
		Button secondButton = new Button("Second Button");
		secondButton.setWidth("200px");
		secondButton.addStyleName("primary");
		secondButton.addClickListener(leftListener);
		leftmenu.addComponent((Component) secondButton, "second");
		Button thirdButton = new Button("Third Button");
		thirdButton.setWidth("200px");
		thirdButton.addStyleName("primary");
		thirdButton.addClickListener(leftListener);
		leftmenu.addComponent((Component) thirdButton, "third");
		
		CustomLayout rightmenu = new CustomLayout("rightmenu");
		Button b01 = new Button("B01");
		b01.addStyleName("friendly");
		b01.addClickListener(rightListener);
		rightmenu.addComponent((Component) b01, "b01");
		Button b02 = new Button("B02");
		b02.addStyleName("friendly");
		b02.addClickListener(rightListener);
		rightmenu.addComponent((Component) b02, "b02");
		Button b03 = new Button("B03");
		b03.addStyleName("friendly");
		b03.addClickListener(rightListener);
		rightmenu.addComponent((Component) b03, "b03");
		Button b04 = new Button("B04");
		b04.addStyleName("friendly");
		b04.addClickListener(rightListener);
		rightmenu.addComponent((Component) b04, "b04");
		
		CustomLayout centerLayout = new CustomLayout("centerlayout");
		centerLayout.setSizeFull();
		centerLayout.addComponent(leftmenu, "left");
		centerLayout.addComponent(centerLabel, "center");
		centerLayout.addComponent(rightmenu, "right");

		Label lHeader = new Label("Header");
		lHeader.addStyleName("mylabelstyle");
		lHeader.setSizeFull();
		Label lFooter = new Label("Footer");
		lFooter.addStyleName("mylabelstyle");
		lFooter.setSizeFull();
		
		layout.addComponent(lHeader, "top");
		layout.addComponent(centerLayout, "center");
		layout.addComponent(lFooter, "bottom");
		
	}

}